#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 42 "grammar.y"

#include "config.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>

#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif

#include "nf_common.h"
#include "rbtree.h"
#include "nfdump.h"
#include "nffile.h"
#include "nftree.h"
#include "ipconv.h"
#include "util.h"

/*
 * function prototypes
 */
static void  yyerror(char *msg);

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type);

static uint64_t VerifyMac(char *s);

enum { DIR_UNSPEC = 1, 
	   SOURCE, DESTINATION, SOURCE_AND_DESTINATION, SOURCE_OR_DESTINATION, 
	   DIR_IN, DIR_OUT, 
	   IN_SRC, IN_DST, OUT_SRC, OUT_DST, 
	   ADJ_PREV, ADJ_NEXT };

/* var defs */
extern int 			lineno;
extern char 		*yytext;
extern uint64_t		*IPstack;
extern uint32_t	StartNode;
extern uint16_t	Extended;
extern int (*FilterEngine)(uint32_t *);
extern char	*FilterFilename;

static uint32_t num_ip;

char yyerror_buff[256];

#define MPLSMAX 0x00ffffff
#line 97 "grammar.y"
typedef union {
	uint64_t		value;
	char			*s;
	FilterParam_t	param;
	void			*list;
} YYSTYPE;
#line 84 "grammar.c"
#define ANY 257
#define IP 258
#define IF 259
#define MAC 260
#define MPLS 261
#define TOS 262
#define DIR 263
#define FLAGS 264
#define PROTO 265
#define MASK 266
#define HOSTNAME 267
#define NET 268
#define PORT 269
#define FWDSTAT 270
#define IN 271
#define OUT 272
#define SRC 273
#define DST 274
#define EQ 275
#define LT 276
#define GT 277
#define PREV 278
#define NEXT 279
#define NUMBER 280
#define STRING 281
#define IDENT 282
#define PORTNUM 283
#define ICMP_TYPE 284
#define ICMP_CODE 285
#define ENGINE_TYPE 286
#define ENGINE_ID 287
#define AS 288
#define PACKETS 289
#define BYTES 290
#define FLOWS 291
#define PPS 292
#define BPS 293
#define BPP 294
#define DURATION 295
#define NOT 296
#define END 297
#define IPV4 298
#define IPV6 299
#define BGPNEXTHOP 300
#define ROUTER 301
#define VLAN 302
#define CLIENT 303
#define SERVER 304
#define APP 305
#define LATENCY 306
#define SYSID 307
#define ASA 308
#define REASON 309
#define DENIED 310
#define XEVENT 311
#define XIP 312
#define XNET 313
#define XPORT 314
#define INGRESS 315
#define EGRESS 316
#define ACL 317
#define ACE 318
#define XACE 319
#define NAT 320
#define ADD 321
#define EVENT 322
#define VRF 323
#define NPORT 324
#define NIP 325
#define OR 326
#define AND 327
#define NEGATE 328
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    7,    7,    7,    7,    7,    8,    8,    8,
    4,    4,    4,    4,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    6,
    6,    5,    5,    5,    1,    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    2,    2,    4,    4,
    3,    3,    3,    3,    3,    4,    3,    2,    3,    6,
    3,    6,    3,    3,    4,    4,    4,    2,    4,    6,
    2,    2,    3,    3,    3,    4,    4,    4,    4,    3,
    5,    4,    4,    3,    4,    4,    4,    3,    4,    6,
    3,    4,    5,    3,    3,    3,    4,    3,    2,    2,
    2,    2,    1,    3,    2,    3,    4,    1,    2,    3,
    0,    1,    1,    1,    0,    1,    1,    3,    3,    3,
    3,    1,    1,    2,    2,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    3,    2,    3,
};
short yydefred[] = {                                      0,
    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   88,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    5,    6,    0,    0,    0,    0,    0,
    0,    0,    0,   91,    0,    0,    0,    0,    0,   95,
    0,    0,    0,   61,   90,   62,   72,   73,   74,   18,
    0,    7,    8,   59,   60,   84,   85,   86,   87,    0,
    0,    0,    0,    0,    4,   31,   32,    0,    0,    0,
    0,    0,    0,    0,   98,    0,    0,    0,    0,    0,
   28,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   92,   93,   94,    0,   58,    0,
   17,   78,   80,   79,   81,    0,   21,   33,   34,   11,
   12,   13,   14,   15,   23,   24,    0,    0,    0,    0,
   35,    0,    0,    0,   44,    0,   99,    0,   97,    0,
   19,   54,   56,    0,   51,    0,    0,    0,    0,    0,
    0,    0,   55,   40,    0,    0,    0,   48,    0,   57,
    0,   25,   26,   27,   39,   38,   37,   36,   46,   45,
    0,   16,   52,    0,    0,   29,    0,   49,    9,   10,
    0,   42,   47,   43,    0,    0,    0,   53,   68,    0,
    0,   41,    0,    0,   22,    0,   20,   69,   30,    0,
   50,   64,    0,   66,   70,   67,
};
short yydgoto[] = {                                      37,
   38,   39,   40,   51,  108,   41,  186,  190,
};
short yysindex[] = {                                     69,
    0, -237, -255, -236, -215, -209, -192, -188, -238, -214,
    0, -231, -224, -230, -204, -253, -253, -253, -253, -253,
 -253, -253,   69,    0,    0, -159, -144, -184, -182, -179,
 -162, -285, -195,    0, -193,   69,    0, -206, -158,    0,
 -223, -147, -253,    0,    0,    0,    0,    0,    0,    0,
 -146,    0,    0,    0,    0,    0,    0,    0,    0, -139,
 -138, -135, -134, -250,    0,    0,    0, -140, -137, -132,
 -131, -130, -129, -128,    0, -124, -123, -253, -253, -253,
    0, -253, -247, -253, -242,  -41,   69,   69, -235, -127,
 -121, -253, -119, -118, -228, -207, -253, -253, -116, -113,
 -109, -253, -253, -108,    0,    0,    0, -253,    0, -115,
    0,    0,    0,    0,    0,   50,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -106, -105, -104, -103,
    0, -263, -102, -101,    0, -100,    0, -185,    0,   71,
    0,    0,    0,  -97,    0,  -44,   93,  -95,   95,  -93,
  -92,  -91,    0,    0,  143,  -89,  -88,    0,  -87,    0,
  -84,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -84,    0,    0,  -81,  -80,    0,  -80,    0,    0,    0,
  -79,    0,    0,    0,  156,  -42,  -39,    0,    0,  -35,
  -34,    0,  -74,  160,    0,  -73,    0,    0,    0,  -71,
    0,    0,  -70,    0,    0,    0,
};
short yyrindex[] = {                                      4,
    0,    0,    0,  -69,    0,    0, -143,  -64,  128,  133,
    0,  206,    0,    0,    0,  -69,  -69,  -69,  -69,  -69,
  -69,  -69,  201,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -212,    0,    0,  201,    0,  212,    0,    0,
    0,    0,  -69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -69,  -69,  -69,
    0,  -69,  -69,  -69,  -69,    0,  201,  201,    0,    0,
    0,  -69,    0,    0,  -69,  -69,  -69,  -69,    0,    0,
    0,  -69,  -69,    0,    0,    0,    0,  -69,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    1,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -38,    0,    0,    0,    0,    0,
    0,    0,    0,  -37,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   -4,    0,    0,   -5,    0,    5,   42,   37,
};
#define YYTABLESIZE 531
short yytable[] = {                                     137,
   96,  196,  174,    1,  196,   63,   65,   46,  200,  200,
   68,   69,   70,   71,   72,   73,   74,  166,   75,   42,
  116,   47,   48,   49,   44,   82,   64,   47,   48,   49,
  117,   86,   47,   48,   49,  140,   83,  110,   47,   48,
   49,   96,  147,   43,   50,  141,   47,   48,   49,   66,
  195,   45,   34,  197,   63,   65,   65,  199,  201,   45,
   34,  131,  132,  149,   52,   53,  135,   47,   48,   49,
   54,   55,  127,  128,  129,   67,  130,  133,  134,  136,
   56,   57,  138,  139,   58,   59,  144,   60,   61,  148,
  150,  151,  152,  105,  106,  107,  156,  157,   76,   89,
   90,   91,  159,   92,   90,   90,   90,   93,   36,   94,
   95,   62,   63,   77,   82,   82,   82,   81,   82,   87,
   88,   78,   82,   79,   82,   82,   80,   84,   85,   96,
   97,   98,  109,  111,  112,  113,  167,  114,  115,  118,
  161,   88,  119,   99,   82,   82,   82,  120,  121,  122,
  123,  124,  142,  100,  101,  102,  125,  126,   82,  143,
  145,  171,  146,  153,  160,  103,  104,  154,   82,   82,
   82,  155,  158,  162,  163,  164,  165,  168,  169,  170,
   82,   82,  172,  175,  176,  177,  178,  179,  180,  181,
  182,  183,  184,   83,   83,   83,  185,   83,  188,  189,
  192,   83,  193,   83,   83,  202,  203,  204,  205,  206,
   71,    2,  187,  191,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   83,   83,   83,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  173,   83,  194,    0,
    0,  194,   63,   65,  198,  198,    0,   83,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   83,
   83,   75,   75,   75,    0,   75,    0,    0,    0,   75,
    0,   75,   75,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   87,   88,    0,    0,    0,    0,
    0,   75,   75,   75,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,   75,   75,    0,    0,
    0,    0,    0,    0,    0,    1,   96,   75,   75,    2,
    0,    3,    4,    5,    0,    0,    0,    0,    6,    7,
    8,    9,   10,    0,    0,    0,   11,   12,    0,    0,
   13,    0,   14,   15,   16,   17,    0,    0,    0,   18,
   19,   20,   21,   22,   23,    0,   24,   25,   26,   27,
    0,   28,   29,   30,    0,   31,   32,    0,    0,    0,
    0,    0,    0,   33,   34,   76,   76,   76,   35,   76,
   77,   77,   77,   76,   77,   76,   76,    0,   77,    0,
   77,   77,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   76,   76,   76,    0,    0,
   77,   77,   77,    0,    0,    0,    0,    0,    0,   76,
    0,    0,    0,    0,   77,    0,    0,    0,    0,   76,
   76,   76,    0,    0,   77,   77,   77,    0,    0,    0,
    0,   76,   76,    0,    0,    0,   77,   77,   75,   75,
   75,    0,   75,    0,   89,   89,   75,   89,   75,   75,
    0,   89,    0,   89,   89,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   75,   75,
   75,    0,    0,   89,   89,   89,    0,    0,    0,    0,
    0,    0,   75,    0,    0,    0,    0,   89,    0,    0,
    0,    0,   75,   75,   75,    0,    0,   89,   89,   89,
    0,    0,    0,    0,   75,   75,    0,    0,    0,   89,
   89,
};
short yycheck[] = {                                      41,
    0,   44,   47,    0,   44,   44,   44,    3,   44,   44,
   16,   17,   18,   19,   20,   21,   22,  281,   23,  257,
  271,  275,  276,  277,  280,  311,  258,  275,  276,  277,
  281,   36,  275,  276,  277,  271,  322,   43,  275,  276,
  277,   41,  271,  281,  281,  281,  275,  276,  277,  280,
   93,  315,  316,   93,   93,   93,  281,   93,   93,  315,
  316,  309,  310,  271,  280,  281,  309,  275,  276,  277,
  280,  281,   78,   79,   80,  280,   82,   83,   84,   85,
  273,  274,   87,   88,  273,  274,   92,  326,  327,   95,
   96,   97,   98,  317,  318,  319,  102,  103,  258,  258,
  259,  260,  108,  262,  317,  318,  319,  266,   40,  268,
  269,  326,  327,  258,  258,  259,  260,  280,  262,  326,
  327,  306,  266,  306,  268,  269,  306,  323,  322,  288,
  289,  290,  280,  280,  274,  274,  132,  273,  273,  280,
   91,  327,  280,  302,  288,  289,  290,  280,  280,  280,
  280,  280,  280,  312,  313,  314,  281,  281,  302,  281,
  280,   91,  281,  280,  280,  324,  325,  281,  312,  313,
  314,  281,  281,  280,  280,  280,  280,  280,  280,  280,
  324,  325,  280,   91,  280,   91,  280,  280,  280,   47,
  280,  280,  280,  258,  259,  260,  281,  262,  280,  280,
  280,  266,   47,  268,  269,  280,   47,  281,  280,  280,
  280,    0,  171,  177,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  281,  302,  281,   -1,
   -1,  281,  281,  281,  280,  280,   -1,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  324,
  325,  258,  259,  260,   -1,  262,   -1,   -1,   -1,  266,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  326,  327,   -1,   -1,   -1,   -1,
   -1,  288,  289,  290,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  302,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  312,  313,  314,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  326,  324,  325,  261,
   -1,  263,  264,  265,   -1,   -1,   -1,   -1,  270,  271,
  272,  273,  274,   -1,   -1,   -1,  278,  279,   -1,   -1,
  282,   -1,  284,  285,  286,  287,   -1,   -1,   -1,  291,
  292,  293,  294,  295,  296,   -1,  298,  299,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,  316,  258,  259,  260,  320,  262,
  258,  259,  260,  266,  262,  268,  269,   -1,  266,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  288,  289,  290,   -1,   -1,
  288,  289,  290,   -1,   -1,   -1,   -1,   -1,   -1,  302,
   -1,   -1,   -1,   -1,  302,   -1,   -1,   -1,   -1,  312,
  313,  314,   -1,   -1,  312,  313,  314,   -1,   -1,   -1,
   -1,  324,  325,   -1,   -1,   -1,  324,  325,  258,  259,
  260,   -1,  262,   -1,  259,  260,  266,  262,  268,  269,
   -1,  266,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,
  290,   -1,   -1,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,   -1,  302,   -1,   -1,   -1,   -1,  302,   -1,   -1,
   -1,   -1,  312,  313,  314,   -1,   -1,  312,  313,  314,
   -1,   -1,   -1,   -1,  324,  325,   -1,   -1,   -1,  324,
  325,
};
#define YYFINAL 37
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 328
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','",0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"ANY","IP","IF","MAC","MPLS","TOS","DIR","FLAGS","PROTO","MASK","HOSTNAME",
"NET","PORT","FWDSTAT","IN","OUT","SRC","DST","EQ","LT","GT","PREV","NEXT",
"NUMBER","STRING","IDENT","PORTNUM","ICMP_TYPE","ICMP_CODE","ENGINE_TYPE",
"ENGINE_ID","AS","PACKETS","BYTES","FLOWS","PPS","BPS","BPP","DURATION","NOT",
"END","IPV4","IPV6","BGPNEXTHOP","ROUTER","VLAN","CLIENT","SERVER","APP",
"LATENCY","SYSID","ASA","REASON","DENIED","XEVENT","XIP","XNET","XPORT",
"INGRESS","EGRESS","ACL","ACE","XACE","NAT","ADD","EVENT","VRF","NPORT","NIP",
"OR","AND","NEGATE",
};
char *yyrule[] = {
"$accept : prog",
"prog :",
"prog : expr",
"term : ANY",
"term : IDENT STRING",
"term : IPV4",
"term : IPV6",
"term : PROTO NUMBER",
"term : PROTO STRING",
"term : dqual PACKETS comp NUMBER",
"term : dqual BYTES comp NUMBER",
"term : FLOWS comp NUMBER",
"term : PPS comp NUMBER",
"term : BPS comp NUMBER",
"term : BPP comp NUMBER",
"term : DURATION comp NUMBER",
"term : dqual TOS comp NUMBER",
"term : FLAGS comp NUMBER",
"term : FLAGS STRING",
"term : dqual IP STRING",
"term : dqual IP IN '[' iplist ']'",
"term : NEXT IP STRING",
"term : NEXT IP IN '[' iplist ']'",
"term : BGPNEXTHOP IP STRING",
"term : ROUTER IP STRING",
"term : CLIENT LATENCY comp NUMBER",
"term : SERVER LATENCY comp NUMBER",
"term : APP LATENCY comp NUMBER",
"term : SYSID NUMBER",
"term : dqual PORT comp NUMBER",
"term : dqual PORT IN '[' ullist ']'",
"term : ICMP_TYPE NUMBER",
"term : ICMP_CODE NUMBER",
"term : ENGINE_TYPE comp NUMBER",
"term : ENGINE_ID comp NUMBER",
"term : ASA EVENT REASON",
"term : ASA EVENT comp NUMBER",
"term : ASA EVENT DENIED inout",
"term : ASA EVENT DENIED STRING",
"term : ASA XEVENT comp NUMBER",
"term : dqual XIP STRING",
"term : dqual XNET STRING '/' NUMBER",
"term : dqual XPORT comp NUMBER",
"term : inout acl comp NUMBER",
"term : NAT EVENT REASON",
"term : NAT EVENT comp NUMBER",
"term : INGRESS VRF comp NUMBER",
"term : dqual NPORT comp NUMBER",
"term : dqual NIP STRING",
"term : dqual AS comp NUMBER",
"term : dqual AS IN '[' ullist ']'",
"term : dqual MASK NUMBER",
"term : dqual NET STRING STRING",
"term : dqual NET STRING '/' NUMBER",
"term : dqual IF NUMBER",
"term : dqual VLAN NUMBER",
"term : dqual MAC STRING",
"term : MPLS STRING comp NUMBER",
"term : MPLS ANY NUMBER",
"term : FWDSTAT NUMBER",
"term : FWDSTAT STRING",
"term : DIR NUMBER",
"term : DIR inout",
"iplist : STRING",
"iplist : STRING '/' NUMBER",
"iplist : iplist STRING",
"iplist : iplist ',' STRING",
"iplist : iplist STRING '/' NUMBER",
"ullist : NUMBER",
"ullist : ullist NUMBER",
"ullist : ullist ',' NUMBER",
"comp :",
"comp : EQ",
"comp : LT",
"comp : GT",
"dqual :",
"dqual : SRC",
"dqual : DST",
"dqual : SRC OR DST",
"dqual : DST OR SRC",
"dqual : SRC AND DST",
"dqual : DST AND SRC",
"dqual : IN",
"dqual : OUT",
"dqual : IN SRC",
"dqual : IN DST",
"dqual : OUT SRC",
"dqual : OUT DST",
"dqual : PREV",
"dqual : NEXT",
"inout : INGRESS",
"inout : EGRESS",
"acl : ACL",
"acl : ACE",
"acl : XACE",
"expr : term",
"expr : expr OR expr",
"expr : expr AND expr",
"expr : NOT expr",
"expr : '(' expr ')'",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 2014 "grammar.y"

static void  yyerror(char *msg) {

	if ( FilterFilename )
		snprintf(yyerror_buff, 255 ,"File '%s' line %d: %s at '%s'", FilterFilename, lineno, msg, yytext);
	else 
		snprintf(yyerror_buff, 255, "Line %d: %s at '%s'", lineno, msg, yytext);

	yyerror_buff[255] = '\0';
	fprintf(stderr, "%s\n", yyerror_buff);

} /* End of yyerror */

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type) {
uint32_t offset_a, offset_b, i, j, block;
	if ( type == SOURCE ) {
		offset_a = offsets[0];
		offset_b = offsets[1];
	} else {
		offset_a = offsets[2];
		offset_b = offsets[3];
	}

	i = 0;
	block = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
	i += 2;
	for ( j=1; j<num_records; j++ ) {
		uint32_t b = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
		block = Connect_OR(block, b);
		i += 2;
	}

	return block;

} // End of ChainHosts

uint64_t VerifyMac(char *s) {
uint64_t mac;
size_t slen = strlen(s);
long l;
char *p, *q, *r;
int i;

	if ( slen > 17 )
		return 0; 

	for (i=0; i<slen; i++ ) {
		if ( !isxdigit(s[i]) && s[i] != ':' ) 
			return 0;
	}

	p = strdup(s);
	if ( !p ) {
		yyerror("malloc() error");
		return 0;
	}

	mac = 0;
	i = 0;	// number of MAC octets must be 6
	r = p;
	q = strchr(r, ':');
	while ( r && i < 6 ) {
		if ( q ) 
			*q = '\0';
		l = strtol(r, NULL, 16);
		if ( (i == 0 && errno == EINVAL) ) {
			free(p);
			return 0;
		}
		if ( l > 255 ) {
			free(p);
			return 0;
		}

		mac = ( mac << 8 ) | (l & 0xFF );
		i++;

		if ( q ) {
			r = ++q;
			q = strchr(r, ':');
		} else 
			r = NULL;
	}

	if ( i != 6 )
		return 0;

	return mac;

} // End of VerifyMac
#line 626 "grammar.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 2:
#line 122 "grammar.y"
{   
		StartNode = yyvsp[0].value; 
	}
break;
case 3:
#line 127 "grammar.y"
{ /* this is an unconditionally true expression, as a filter applies in any case */
		yyval.param.self = NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL ); 
	}
break;
case 4:
#line 131 "grammar.y"
{	
		if ( !ScreenIdentString(yyvsp[0].s) ) {
			yyerror("Illegal ident string");
			YYABORT;
		}

		uint32_t	index = AddIdent(yyvsp[0].s);
		yyval.param.self = NewBlock(0, 0, index, CMP_IDENT, FUNC_NONE, NULL ); 
	}
break;
case 5:
#line 141 "grammar.y"
{ 
		yyval.param.self = NewBlock(OffsetRecordFlags, (1LL << ShiftRecordFlags)  & MaskRecordFlags, 
					(0LL << ShiftRecordFlags)  & MaskRecordFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
break;
case 6:
#line 146 "grammar.y"
{ 
		yyval.param.self = NewBlock(OffsetRecordFlags, (1LL << ShiftRecordFlags)  & MaskRecordFlags, 
					(1LL << ShiftRecordFlags)  & MaskRecordFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
break;
case 7:
#line 151 "grammar.y"
{ 
		int64_t	proto;
		proto = yyvsp[0].value;

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 

	}
break;
case 8:
#line 167 "grammar.y"
{ 
		int64_t	proto;
		proto = Proto_num(yyvsp[0].s);

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 
	}
break;
case 9:
#line 182 "grammar.y"
{ 

		switch ( yyvsp[-3].param.direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				yyval.param.self = NewBlock(OffsetPackets, MaskPackets, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				yyval.param.self = NewBlock(OffsetOutPackets, MaskPackets, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 10:
#line 200 "grammar.y"
{	

		switch ( yyvsp[-3].param.direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				yyval.param.self = NewBlock(OffsetBytes, MaskBytes, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				yyval.param.self = NewBlock(OffsetOutBytes, MaskBytes, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 11:
#line 217 "grammar.y"
{	
			yyval.param.self = NewBlock(OffsetAggrFlows, MaskFlows, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
	}
break;
case 12:
#line 221 "grammar.y"
{	
		yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_PPS, NULL); 
	}
break;
case 13:
#line 225 "grammar.y"
{	
		yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_BPS, NULL); 
	}
break;
case 14:
#line 229 "grammar.y"
{	
		yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_BPP, NULL); 
	}
break;
case 15:
#line 233 "grammar.y"
{	
		yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_DURATION, NULL); 
	}
break;
case 16:
#line 237 "grammar.y"
{	
		if ( yyvsp[0].value > 255 ) {
			yyerror("TOS must be 0..255");
			YYABORT;
		}

		switch ( yyvsp[-3].param.direction ) {
			case DIR_UNSPEC:
			case SOURCE:
				yyval.param.self = NewBlock(OffsetTos, MaskTos, (yyvsp[0].value << ShiftTos) & MaskTos, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetDstTos, MaskDstTos, (yyvsp[0].value << ShiftDstTos) & MaskDstTos, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
				break;
			case SOURCE_OR_DESTINATION: 
				yyval.param.self = Connect_OR(
					NewBlock(OffsetTos, MaskTos, (yyvsp[0].value << ShiftTos) & MaskTos, yyvsp[-1].param.comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, (yyvsp[0].value << ShiftDstTos) & MaskDstTos, yyvsp[-1].param.comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetTos, MaskTos, (yyvsp[0].value << ShiftTos) & MaskTos, yyvsp[-1].param.comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, (yyvsp[0].value << ShiftDstTos) & MaskDstTos, yyvsp[-1].param.comp, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
			}
	}
break;
case 17:
#line 269 "grammar.y"
{	
		if ( yyvsp[0].value > 63 ) {
			yyerror("Flags must be 0..63");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetFlags, MaskFlags, (yyvsp[0].value << ShiftFlags) & MaskFlags, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
	}
break;
case 18:
#line 277 "grammar.y"
{	
		uint64_t fl = 0;
		int cnt     = 0;
		size_t		len = strlen(yyvsp[0].s);

		if ( len > 7 ) {
			yyerror("Too many flags");
			YYABORT;
		}

		if ( strchr(yyvsp[0].s, 'F') ) { fl |=  1; cnt++; }
		if ( strchr(yyvsp[0].s, 'S') ) { fl |=  2; cnt++; }
		if ( strchr(yyvsp[0].s, 'R') ) { fl |=  4; cnt++; }
		if ( strchr(yyvsp[0].s, 'P') ) { fl |=  8; cnt++; }
		if ( strchr(yyvsp[0].s, 'A') ) { fl |=  16; cnt++; }
		if ( strchr(yyvsp[0].s, 'U') ) { fl |=  32; cnt++; }
		if ( strchr(yyvsp[0].s, 'X') ) { fl =  63; cnt++; }

		if ( cnt != len ) {
			yyerror("Too many flags");
			YYABORT;
		}

		yyval.param.self = NewBlock(OffsetFlags, (fl << ShiftFlags) & MaskFlags, 
					(fl << ShiftFlags) & MaskFlags, CMP_FLAGS, FUNC_NONE, NULL); 
	}
break;
case 19:
#line 304 "grammar.y"
{ 	
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		/* ret == -1 will never happen here, as ALLOW_LOOKUP is set*/
		if ( ret == -2 ) {
			/* could not resolv host => 'not any'*/
			yyval.param.self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetSrcIPv6a, OffsetSrcIPv6b, OffsetDstIPv6a, OffsetDstIPv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( yyvsp[-2].param.direction ) {
				case SOURCE:
				case DESTINATION:
					yyval.param.self = ChainHosts(offsets, IPstack, num_ip, yyvsp[-2].param.direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} /* End of switch*/

		}
	}
break;
case 20:
#line 350 "grammar.y"
{ 	

		switch ( yyvsp[-5].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}
	}
break;
case 21:
#line 378 "grammar.y"
{ 	
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		yyval.param.self = Connect_AND(
			NewBlock(OffsetNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
break;
case 22:
#line 405 "grammar.y"
{ 	

		yyval.param.self = NewBlock(OffsetNexthopv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)yyvsp[-1].list );

	}
break;
case 23:
#line 411 "grammar.y"
{ 	
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		yyval.param.self = Connect_AND(
			NewBlock(OffsetBGPNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetBGPNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
break;
case 24:
#line 438 "grammar.y"
{ 	
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		yyval.param.self = Connect_AND(
			NewBlock(OffsetRouterv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetRouterv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
break;
case 25:
#line 465 "grammar.y"
{ 	
		yyval.param.self = NewBlock(OffsetClientLatency, MaskLatency, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
	}
break;
case 26:
#line 469 "grammar.y"
{ 	
		yyval.param.self = NewBlock(OffsetServerLatency, MaskLatency, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
	}
break;
case 27:
#line 473 "grammar.y"
{ 	
		yyval.param.self = NewBlock(OffsetAppLatency, MaskLatency, yyvsp[0].value, yyvsp[-1].param.comp, FUNC_NONE, NULL); 
	}
break;
case 28:
#line 477 "grammar.y"
{ 	
		if ( yyvsp[0].value > 255 ) {
			yyerror("Router SysID expected between be 1..255");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetExporterSysID, MaskExporterSysID, (yyvsp[0].value << ShiftExporterSysID) & MaskExporterSysID, CMP_EQ, FUNC_NONE, NULL); 
	}
break;
case 29:
#line 485 "grammar.y"
{	
		if ( yyvsp[0].value > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( yyvsp[-3].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetPort, MaskSrcPort, (yyvsp[0].value << ShiftSrcPort) & MaskSrcPort, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetPort, MaskDstPort, (yyvsp[0].value << ShiftDstPort) & MaskDstPort, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, (yyvsp[0].value << ShiftSrcPort) & MaskSrcPort, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, (yyvsp[0].value << ShiftDstPort) & MaskDstPort, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, (yyvsp[0].value << ShiftSrcPort) & MaskSrcPort, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, (yyvsp[0].value << ShiftDstPort) & MaskDstPort, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End switch*/

	}
break;
case 30:
#line 518 "grammar.y"
{ 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		if ( yyvsp[-5].param.direction == DIR_UNSPEC || yyvsp[-5].param.direction == SOURCE_OR_DESTINATION || yyvsp[-5].param.direction == SOURCE_AND_DESTINATION ) {
			/* src and/or dst port*/
			/* we need a second rbtree due to different shifts for src and dst ports*/
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
				if ( node->value > 65535 ) {
					yyerror("Port outside of range 0..65535");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstPort) & MaskDstPort;
				node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( yyvsp[-5].param.direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
					node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				}
				yyval.param.self = NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
					node->value = (node->value << ShiftDstPort) & MaskDstPort;
				}
				yyval.param.self = NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 31:
#line 582 "grammar.y"
{
		if ( yyvsp[0].value > 255 ) {
			yyerror("ICMP tpye of range 0..15");
			YYABORT;
		}
		yyval.param.self = Connect_AND(
			/* imply proto ICMP with a proto ICMP block*/
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetPort, MaskICMPtype, (yyvsp[0].value << ShiftICMPtype) & MaskICMPtype, CMP_EQ, FUNC_NONE, NULL )
		);

	}
break;
case 32:
#line 598 "grammar.y"
{
		if ( yyvsp[0].value > 255 ) {
			yyerror("ICMP code of range 0..15");
			YYABORT;
		}
		yyval.param.self = Connect_AND(
			/* imply proto ICMP with a proto ICMP block*/
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetPort, MaskICMPcode, (yyvsp[0].value << ShiftICMPcode) & MaskICMPcode, CMP_EQ, FUNC_NONE, NULL )
		);

	}
break;
case 33:
#line 614 "grammar.y"
{
		if ( yyvsp[0].value > 255 ) {
			yyerror("Engine type of range 0..255");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetRouterID, MaskEngineType, (yyvsp[0].value << ShiftEngineType) & MaskEngineType, yyvsp[-1].param.comp, FUNC_NONE, NULL);

	}
break;
case 34:
#line 623 "grammar.y"
{
		if ( yyvsp[0].value > 255 ) {
			yyerror("Engine ID of range 0..255");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetRouterID, MaskEngineID, (yyvsp[0].value << ShiftEngineID) & MaskEngineID, yyvsp[-1].param.comp, FUNC_NONE, NULL);

	}
break;
case 35:
#line 632 "grammar.y"
{
#ifdef NSEL
		if ( strncasecmp(yyvsp[0].s,"ignore", 6) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_IGNORE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp(yyvsp[0].s,"create", 6) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_CREATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp(yyvsp[0].s,"term", 4) == 0 || strncasecmp(yyvsp[0].s,"delete", 6) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DELETE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp(yyvsp[0].s,"deny", 4) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp(yyvsp[0].s,"alert", 5) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_ALERT << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp(yyvsp[0].s,"update", 6) == 0) {
			yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_UPDATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown asa event");
			YYABORT;
		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 36:
#line 656 "grammar.y"
{
#ifdef NSEL
		if ( yyvsp[0].value > 255 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetConnID, MaskFWevent, ( yyvsp[0].value << ShiftFWevent) & MaskFWevent, yyvsp[-1].param.comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 37:
#line 669 "grammar.y"
{
#ifdef NSEL
		uint64_t xevent = 0;
		if ( yyvsp[0].param.inout == INGRESS ) {
			xevent = 1001;
		} else if ( yyvsp[0].param.inout == EGRESS ) {
			xevent = 1002;
		} else {
				yyerror("Invalid inout token");
				YYABORT;
		}
		yyval.param.self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 38:
#line 689 "grammar.y"
{
#ifdef NSEL
		uint64_t xevent = 0;
		if( strncasecmp(yyvsp[0].s,"interface", 6) == 0) {
			xevent = 1003;
		} else if( strncasecmp(yyvsp[0].s,"nosyn", 6) == 0) {
			xevent = 1004;
		} else {
			xevent = (uint64_t)strtol(yyvsp[0].s, (char **)NULL, 10);
			if ( (xevent == 0 && errno == EINVAL) || xevent > 65535 ) {
				yyerror("Invalid xevent ID");
				YYABORT;
			}
		}
		yyval.param.self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 39:
#line 713 "grammar.y"
{
#ifdef NSEL
		if ( yyvsp[0].value > 65535 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetConnID, MaskFWXevent, ( yyvsp[0].value << ShiftFWXevent) & MaskFWXevent, yyvsp[-1].param.comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 40:
#line 726 "grammar.y"
{ 	
#ifdef NSEL
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		/* ret == -1 will never happen here, as ALLOW_LOOKUP is set*/
		if ( ret == -2 ) {
			/* could not resolv host => 'not any'*/
			yyval.param.self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetXLATESRCv6a, OffsetXLATESRCv6b, OffsetXLATEDSTv6a, OffsetXLATEDSTv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( yyvsp[-2].param.direction ) {
				case SOURCE:
				case DESTINATION:
					yyval.param.self = ChainHosts(offsets, IPstack, num_ip, yyvsp[-2].param.direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} /* End of switch*/

		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 41:
#line 777 "grammar.y"
{ 
#ifdef NSEL
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, yyvsp[-2].s, IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/


		if ( yyvsp[0].value > (bytes*8) ) {
			yyerror("Too many netbits for this IP addresss");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - yyvsp[0].value );
		} else {	/* PF_INET6*/
			if ( yyvsp[0].value > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - yyvsp[0].value );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - yyvsp[0].value );
				mask[1] = 0;
			}
		}
		/* IP aadresses are stored in network representation */
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( yyvsp[-4].param.direction ) {
			case SOURCE:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 42:
#line 867 "grammar.y"
{	
#ifdef NSEL
		if ( yyvsp[0].value > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( yyvsp[-3].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End switch*/
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif

	}
break;
case 43:
#line 905 "grammar.y"
{
#ifdef NSEL
		uint64_t offset, mask, shift;
		if ( yyvsp[-3].param.inout == INGRESS ) {
			switch (yyvsp[-2].param.acl) {
				case ACL:
					offset = OffsetIngressAclId;
					mask   = MaskIngressAclId;	
					shift  = ShiftIngressAclId;
					break;
				case ACE:
					offset = OffsetIngressAceId;
					mask   = MaskIngressAceId;	
					shift  = ShiftIngressAceId;
					break;
				case XACE:
					offset = OffsetIngressGrpId;
					mask   = MaskIngressGrpId;	
					shift  = ShiftIngressGrpId;
					break;
				default:
					yyerror("Invalid ACL specifier");
					YYABORT;
			}
		} else if ( yyvsp[-3].param.inout == EGRESS && yyval.param.acl == ACL ) {
			offset = OffsetEgressAclId;
			mask   = MaskEgressAclId;	
			shift  = ShiftEgressAclId;
		} else {
			yyerror("ingress/egress syntax error");
			YYABORT;
		}
		yyval.param.self = NewBlock(offset, mask, (yyvsp[0].value << shift) & mask , yyvsp[-1].param.comp, FUNC_NONE, NULL );

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 44:
#line 945 "grammar.y"
{
#ifdef NSEL
		if ( strncasecmp(yyvsp[0].s,"invalid", 6) == 0) {
			yyval.param.self = NewBlock(OffsetNELcommon, MasNATevent, ( NEL_EVENT_INVALID << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp(yyvsp[0].s,"add", 6) == 0) {
			yyval.param.self = NewBlock(OffsetNELcommon, MasNATevent, ( NEL_EVENT_ADD << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp(yyvsp[0].s,"delete", 4) == 0 || strncasecmp(yyvsp[0].s,"delete", 6) == 0) {
			yyval.param.self = NewBlock(OffsetNELcommon, MasNATevent, ( NEL_EVENT_DELETE << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown nat event");
			YYABORT;
		}
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif
	}
break;
case 45:
#line 963 "grammar.y"
{
#ifdef NSEL
		if ( yyvsp[0].value > 255 ) {
			yyerror("Invalid event ID");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetNELcommon, MasNATevent, ( yyvsp[0].value << ShiftNATevent) & MasNATevent, yyvsp[-1].param.comp, FUNC_NONE, NULL );
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif
	}
break;
case 46:
#line 976 "grammar.y"
{
#ifdef NSEL
		if ( yyvsp[0].value > 0xFFFFFFFFLL ) {
			yyerror("Invalid vrf ID");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetVRFID, MaskVRFID, ( yyvsp[0].value << ShiftVRFID) & MaskVRFID, yyvsp[-1].param.comp, FUNC_NONE, NULL );
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif
	}
break;
case 47:
#line 989 "grammar.y"
{	
#ifdef NSEL
		if ( yyvsp[0].value > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( yyvsp[-3].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, (yyvsp[0].value << ShiftXLATESRCPORT) & MaskXLATESRCPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, (yyvsp[0].value << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, yyvsp[-1].param.comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End switch*/
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif

	}
break;
case 48:
#line 1027 "grammar.y"
{ 	
#ifdef NSEL
		int af, bytes, ret;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		/* ret == -1 will never happen here, as ALLOW_LOOKUP is set*/
		if ( ret == -2 ) {
			/* could not resolv host => 'not any'*/
			yyval.param.self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetXLATESRCv6a, OffsetXLATESRCv6b, OffsetXLATEDSTv6a, OffsetXLATEDSTv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( yyvsp[-2].param.direction ) {
				case SOURCE:
				case DESTINATION:
					yyval.param.self = ChainHosts(offsets, IPstack, num_ip, yyvsp[-2].param.direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					yyval.param.self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} /* End of switch*/

		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
break;
case 49:
#line 1078 "grammar.y"
{	
		if ( yyvsp[0].value > 0xfFFFFFFF ) {
			yyerror("AS number of range");
			YYABORT;
		}

		switch ( yyvsp[-3].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetAS, MaskSrcAS, (yyvsp[0].value << ShiftSrcAS) & MaskSrcAS, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetAS, MaskDstAS, (yyvsp[0].value << ShiftDstAS) & MaskDstAS, yyvsp[-1].param.comp, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, (yyvsp[0].value << ShiftSrcAS) & MaskSrcAS, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, (yyvsp[0].value << ShiftDstAS) & MaskDstAS, yyvsp[-1].param.comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, (yyvsp[0].value << ShiftSrcAS) & MaskSrcAS, yyvsp[-1].param.comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, (yyvsp[0].value << ShiftDstAS) & MaskDstAS, yyvsp[-1].param.comp, FUNC_NONE, NULL)
				);
				break;
			case ADJ_PREV:
				yyval.param.self = NewBlock(OffsetBGPadj, MaskBGPadjPrev, (yyvsp[0].value << ShiftBGPadjPrev) & MaskBGPadjPrev, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			case ADJ_NEXT:
				yyval.param.self = NewBlock(OffsetBGPadj, MaskBGPadjNext, (yyvsp[0].value << ShiftBGPadjNext) & MaskBGPadjNext, yyvsp[-1].param.comp, FUNC_NONE, NULL );
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 50:
#line 1117 "grammar.y"
{ 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		if ( yyvsp[-5].param.direction == DIR_UNSPEC || yyvsp[-5].param.direction == SOURCE_OR_DESTINATION || yyvsp[-5].param.direction == SOURCE_AND_DESTINATION ) {
			/* src and/or dst AS*/
			/* we need a second rbtree due to different shifts for src and dst AS*/
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
				if ( node->value > 0xFFFFFFFFLL ) {
					yyerror("AS number of range");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstAS) & MaskDstAS;
				node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( yyvsp[-5].param.direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
					node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				}
				yyval.param.self = NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)yyvsp[-1].list) {
					node->value = (node->value << ShiftDstAS) & MaskDstAS;
				}
				yyval.param.self = NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)yyvsp[-1].list ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}

	}
break;
case 51:
#line 1181 "grammar.y"
{	
		if ( yyvsp[0].value > 255 ) {
			yyerror("Mask outside of range 0..255");
			YYABORT;
		}

		switch ( yyvsp[-2].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetMask, MaskSrcMask, (yyvsp[0].value << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetMask, MaskDstMask, (yyvsp[0].value << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetMask, MaskSrcMask, (yyvsp[0].value << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, (yyvsp[0].value << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetMask, MaskSrcMask, (yyvsp[0].value << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, (yyvsp[0].value << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End switch*/

	}
break;
case 52:
#line 1214 "grammar.y"
{ 
		int af, bytes, ret;
		uint64_t	mask[2];
		ret = parse_ip(&af, yyvsp[-1].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/

		if ( af != PF_INET ) {
			yyerror("IP netmask syntax valid only for IPv4");
			YYABORT;
		}
		if ( bytes != 4 ) {
			yyerror("Need complete IP address");
			YYABORT;
		}

		ret = parse_ip(&af, yyvsp[0].s, mask, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/

		if ( af != PF_INET || bytes != 4 ) {
			yyerror("Invalid netmask for IPv4 address");
			YYABORT;
		}

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( yyvsp[-3].param.direction ) {
			case SOURCE:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);		
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 53:
#line 1304 "grammar.y"
{ 
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, yyvsp[-2].s, IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		/* ret == -2 will never happen here, as STRICT_IP is set*/


		if ( yyvsp[0].value > (bytes*8) ) {
			yyerror("Too many netbits for this IP addresss");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - yyvsp[0].value );
		} else {	/* PF_INET6*/
			if ( yyvsp[0].value > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - yyvsp[0].value );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - yyvsp[0].value );
				mask[1] = 0;
			}
		}
		/* IP aadresses are stored in network representation */
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( yyvsp[-4].param.direction ) {
			case SOURCE:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 54:
#line 1389 "grammar.y"
{
		if ( yyvsp[0].value > 0xffffffffLL ) {
			yyerror("Input interface number must 0..2^32");
			YYABORT;
		}

		switch ( yyvsp[-2].param.direction ) {
			case DIR_UNSPEC:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetInOut, MaskInput, (yyvsp[0].value << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL),
					NewBlock(OffsetInOut, MaskOutput, (yyvsp[0].value << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case DIR_IN: 
				yyval.param.self = NewBlock(OffsetInOut, MaskInput, (yyvsp[0].value << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				yyval.param.self = NewBlock(OffsetInOut, MaskOutput, (yyvsp[0].value << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 55:
#line 1415 "grammar.y"
{	
		if ( yyvsp[0].value > 65535 ) {
			yyerror("VLAN number of range 0..65535");
			YYABORT;
		}

		switch ( yyvsp[-2].param.direction ) {
			case SOURCE:
				yyval.param.self = NewBlock(OffsetVlan, MaskSrcVlan, (yyvsp[0].value << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				yyval.param.self = NewBlock(OffsetVlan, MaskDstVlan, (yyvsp[0].value << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				yyval.param.self = Connect_OR(
					NewBlock(OffsetVlan, MaskSrcVlan, (yyvsp[0].value << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, (yyvsp[0].value << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				yyval.param.self = Connect_AND(
					NewBlock(OffsetVlan, MaskSrcVlan, (yyvsp[0].value << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, (yyvsp[0].value << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/

	}
break;
case 56:
#line 1448 "grammar.y"
{
		uint64_t	mac = VerifyMac(yyvsp[0].s);
		if ( mac == 0 ) {
			yyerror("Invalid MAC address format");
			YYABORT;
		}
		switch ( yyvsp[-2].param.direction ) {
			case DIR_UNSPEC: {
					uint32_t in, out;
					in  = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					out  = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					yyval.param.self = Connect_OR(in, out);
					} break;
			case DIR_IN:
					yyval.param.self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DIR_OUT:
					yyval.param.self = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case SOURCE:
					yyval.param.self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DESTINATION:
					yyval.param.self = Connect_OR(
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case IN_SRC: 
					yyval.param.self = NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case IN_DST: 
					yyval.param.self = NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_SRC: 
					yyval.param.self = NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_DST:
					yyval.param.self = NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} /* End of switch*/
	}
break;
case 57:
#line 1510 "grammar.y"
{	
		if ( yyvsp[0].value > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}

		/* search for label1 - label10*/
		if ( strncasecmp(yyvsp[-2].s, "label", 5) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &yyvsp[-2].s[5];
			if ( s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			yyval.param.self = NewBlock(offset, mask, (yyvsp[0].value << shift) & mask, yyvsp[-1].param.comp, FUNC_NONE, NULL );

		} else if ( strcasecmp(yyvsp[-2].s, "eos") == 0 ) {
			/* match End of Stack label */
			yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value << 4, yyvsp[-1].param.comp, FUNC_MPLS_EOS, NULL );

		} else if ( strncasecmp(yyvsp[-2].s, "exp", 3) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &yyvsp[-2].s[3];
			if ( s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			if ( yyvsp[0].value > 7 ) {
				yyerror("MPLS exp value out of range");
				YYABORT;
			}

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			yyval.param.self = NewBlock(offset, mask, yyvsp[0].value << shift, yyvsp[-1].param.comp, FUNC_NONE, NULL );

		} else {
			yyerror("Unknown MPLS option");
			YYABORT;
		}
	}
break;
case 58:
#line 1665 "grammar.y"
{	
		uint32_t *opt = malloc(sizeof(uint32_t));
		if ( yyvsp[0].value > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}
		if ( opt == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		*opt = yyvsp[0].value << 4;
		yyval.param.self = NewBlock(0, AnyMask, yyvsp[0].value << 4, CMP_EQ, FUNC_MPLS_ANY, opt );

	}
break;
case 59:
#line 1679 "grammar.y"
{
		if ( yyvsp[0].value > 255 ) {
			yyerror("Forwarding status of range 0..255");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetStatus, MaskStatus, (yyvsp[0].value << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);
	}
break;
case 60:
#line 1687 "grammar.y"
{
		uint64_t id = Get_fwd_status_id(yyvsp[0].s);
		if (id == 256 ) {
			yyerror("Unknown forwarding status");
			YYABORT;
		}

		yyval.param.self = NewBlock(OffsetStatus, MaskStatus, (id << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);

	}
break;
case 61:
#line 1698 "grammar.y"
{
		if ( yyvsp[0].value > 2 ) {
			yyerror("Flow direction status of range 0, 1");
			YYABORT;
		}
		yyval.param.self = NewBlock(OffsetDir, MaskDir, (yyvsp[0].value << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
break;
case 62:
#line 1707 "grammar.y"
{
		uint64_t dir = 0xFF;
		if ( yyvsp[0].param.inout == INGRESS )
			dir = 0;
		else if ( yyvsp[0].param.inout == EGRESS )
			dir = 1;
		else {
			yyerror("Flow direction status of range ingress, egress");
			YYABORT;
		}

		yyval.param.self = NewBlock(OffsetDir, MaskDir, (dir << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
break;
case 63:
#line 1723 "grammar.y"
{ 
		int i, af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		/* ret == -1 will never happen here, as ALLOW_LOOKUP is set*/
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
				RB_INSERT(IPtree, root, node);
			}

		}
		yyval.list = (void *)root;

	}
break;
case 64:
#line 1766 "grammar.y"
{ 
		int af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, yyvsp[-2].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		/* ret == -1 will never happen here, as ALLOW_LOOKUP is set*/
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}

			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - yyvsp[0].value );
			} else {	/* PF_INET6*/
				if ( yyvsp[0].value > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - yyvsp[0].value );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - yyvsp[0].value );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, root, node);

		}
		yyval.list = (void *)root;

	}
break;
case 65:
#line 1820 "grammar.y"
{ 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		/* ret == - 2 means lookup failure*/
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)yyval.list, node);
			}
		}
	}
break;
case 66:
#line 1851 "grammar.y"
{ 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, yyvsp[0].s, IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		/* ret == - 2 means lookup failure*/
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)yyval.list, node);
			}
		}
	}
break;
case 67:
#line 1883 "grammar.y"
{ 
		int af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, yyvsp[-2].s, IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		/* ret == - 2 means lookup failure*/
		if ( ret != -2 ) {
			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - yyvsp[0].value );
			} else {	/* PF_INET6*/
				if ( yyvsp[0].value > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - yyvsp[0].value );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - yyvsp[0].value );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, (IPlist_t *)yyval.list, node);
		}
	}
break;
case 68:
#line 1927 "grammar.y"
{ 
		struct ULongListNode *node;

		ULongtree_t *root = malloc(sizeof(ULongtree_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = yyvsp[0].value;

		RB_INSERT(ULongtree, root, node);
		yyval.list = (void *)root;
	}
break;
case 69:
#line 1948 "grammar.y"
{ 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = yyvsp[0].value;
		RB_INSERT(ULongtree, (ULongtree_t *)yyval.list, node);
	}
break;
case 70:
#line 1959 "grammar.y"
{ 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = yyvsp[0].value;
		RB_INSERT(ULongtree, (ULongtree_t *)yyval.list, node);
	}
break;
case 71:
#line 1973 "grammar.y"
{ yyval.param.comp = CMP_EQ; }
break;
case 72:
#line 1974 "grammar.y"
{ yyval.param.comp = CMP_EQ; }
break;
case 73:
#line 1975 "grammar.y"
{ yyval.param.comp = CMP_LT; }
break;
case 74:
#line 1976 "grammar.y"
{ yyval.param.comp = CMP_GT; }
break;
case 75:
#line 1980 "grammar.y"
{ yyval.param.direction = DIR_UNSPEC;  			 }
break;
case 76:
#line 1981 "grammar.y"
{ yyval.param.direction = SOURCE;				 }
break;
case 77:
#line 1982 "grammar.y"
{ yyval.param.direction = DESTINATION;			 }
break;
case 78:
#line 1983 "grammar.y"
{ yyval.param.direction = SOURCE_OR_DESTINATION;  }
break;
case 79:
#line 1984 "grammar.y"
{ yyval.param.direction = SOURCE_OR_DESTINATION;  }
break;
case 80:
#line 1985 "grammar.y"
{ yyval.param.direction = SOURCE_AND_DESTINATION; }
break;
case 81:
#line 1986 "grammar.y"
{ yyval.param.direction = SOURCE_AND_DESTINATION; }
break;
case 82:
#line 1987 "grammar.y"
{ yyval.param.direction = DIR_IN;				 }
break;
case 83:
#line 1988 "grammar.y"
{ yyval.param.direction = DIR_OUT;				 }
break;
case 84:
#line 1989 "grammar.y"
{ yyval.param.direction = IN_SRC;				 }
break;
case 85:
#line 1990 "grammar.y"
{ yyval.param.direction = IN_DST;				 }
break;
case 86:
#line 1991 "grammar.y"
{ yyval.param.direction = OUT_SRC;				 }
break;
case 87:
#line 1992 "grammar.y"
{ yyval.param.direction = OUT_DST;				 }
break;
case 88:
#line 1993 "grammar.y"
{ yyval.param.direction = ADJ_PREV;				 }
break;
case 89:
#line 1994 "grammar.y"
{ yyval.param.direction = ADJ_NEXT;				 }
break;
case 90:
#line 1997 "grammar.y"
{ yyval.param.inout	= INGRESS;	}
break;
case 91:
#line 1998 "grammar.y"
{ yyval.param.inout	= EGRESS;   }
break;
case 92:
#line 2001 "grammar.y"
{ yyval.param.acl = ACL; 	}
break;
case 93:
#line 2002 "grammar.y"
{ yyval.param.acl = ACE;		}
break;
case 94:
#line 2003 "grammar.y"
{ yyval.param.acl = XACE;	}
break;
case 95:
#line 2006 "grammar.y"
{ yyval.value = yyvsp[0].param.self;        }
break;
case 96:
#line 2007 "grammar.y"
{ yyval.value = Connect_OR(yyvsp[-2].value, yyvsp[0].value);  }
break;
case 97:
#line 2008 "grammar.y"
{ yyval.value = Connect_AND(yyvsp[-2].value, yyvsp[0].value); }
break;
case 98:
#line 2009 "grammar.y"
{ yyval.value = Invert(yyvsp[0].value);			}
break;
case 99:
#line 2010 "grammar.y"
{ yyval.value = yyvsp[-1].value; }
break;
#line 2908 "grammar.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
